Subject: Re: [PATCH] arm64: mm: account for hotplug memory when randomizing the linear region

From: Greg KH <[email-masked]>
Date: Mon, 20 Jan 2025 14:59:44 +0100

On Mon, Jan 13, 2025 at 07:44:50AM -0800, Florian Fainelli wrote:
> 
> 
> On 1/12/2025 3:54 AM, Greg KH wrote:
> > On Thu, Jan 09, 2025 at 09:01:13AM -0800, Florian Fainelli wrote:
> > > On 1/9/25 08:54, Florian Fainelli wrote:
> > > > From: Ard Biesheuvel <[email-masked]>
> > > > 
> > > > commit 97d6786e0669daa5c2f2d07a057f574e849dfd3e upstream
> > > > 
> > > > As a hardening measure, we currently randomize the placement of
> > > > physical memory inside the linear region when KASLR is in effect.
> > > > Since the random offset at which to place the available physical
> > > > memory inside the linear region is chosen early at boot, it is
> > > > based on the memblock description of memory, which does not cover
> > > > hotplug memory. The consequence of this is that the randomization
> > > > offset may be chosen such that any hotplugged memory located above
> > > > memblock_end_of_DRAM() that appears later is pushed off the end of
> > > > the linear region, where it cannot be accessed.
> > > > 
> > > > So let's limit this randomization of the linear region to ensure
> > > > that this can no longer happen, by using the CPU's addressable PA
> > > > range instead. As it is guaranteed that no hotpluggable memory will
> > > > appear that falls outside of that range, we can safely put this PA
> > > > range sized window anywhere in the linear region.
> > > > 
> > > > Signed-off-by: Ard Biesheuvel <[email-masked]>
> > > > Cc: Anshuman Khandual <[email-masked]>
> > > > Cc: Will Deacon <[email-masked]>
> > > > Cc: Steven Price <[email-masked]>
> > > > Cc: Robin Murphy <[email-masked]>
> > > > Link: https://lore.kernel.org/r/[email-masked]
> > > > Signed-off-by: Catalin Marinas <[email-masked]>
> > > > Signed-off-by: Florian Fainelli <[email-masked]>
> > > 
> > > Forgot to update the patch subject, but this one is for 5.10.
> > 
> > You also forgot to tell us _why_ this is needed :(
> 
> This is explained in the second part of the first paragraph:
> 
> The consequence of this is that the randomization offset may be chosen such
> that any hotplugged memory located above memblock_end_of_DRAM() that appears
> later is pushed off the end of the linear region, where it cannot be
> accessed.
> 
> We use both memory hotplug and KASLR on our systems and that's how we
> eventually found out about the bug.

And you still have 5.10.y ARM64 systems that need this?  Why not move to
a newer kernel version already?

Anyway, I need an ack from the ARM64 maintainers that this is ok to
apply here before I can take it.

thanks,

greg k-h